=== debian/changelog ===
rawtherapee (5.0-1) unstable; urgency=medium

  * New upstream release.

 -- Philip Rinn <rinni@inventati.org>  Mon, 23 Jan 2017 16:37:12 +0100

rawtherapee (4.2.1395-1) unstable; urgency=medium

  * New upstream snapshot (closes: #841498).
  * Remove patch patch/01-fix-overflow-in-dcraw.patch:
    - It's applied upstream
  * Bump debhelper compat from 9 to 10 (no changes necessary).
  * Make build reproducible on i386.

 -- Philip Rinn <rinni@inventati.org>  Wed, 16 Nov 2016 23:46:17 +0100

rawtherapee (4.2.1241-2) unstable; urgency=medium

  * Close fixed bugs (closes: #769028, #801540, #822537)
  * Add patch patch/01-fix-overflow-in-dcraw.patch:
    - Fix buffer overflow in dcraw (CVE-2015-8366)

 -- Philip Rinn <rinni@inventati.org>  Fri, 30 Sep 2016 23:16:25 +0200

rawtherapee (4.2.1241-1) unstable; urgency=medium

  * New upstream snapshot:
    - Switch to branch 'gtk3'
  * Remove all patches as they are merged upstream
  * Update build dependencies

 -- Philip Rinn <rinni@inventati.org>  Fri, 30 Sep 2016 21:05:52 +0200

rawtherapee (4.2-5) unstable; urgency=medium

  * Use secure URIs for vcs-* in debian/control.
  * Add patch/06_fix_ftbfs_on_i386-armhf.patch:
    - Use std::abs() in rtefix/rtexif.h
  * Bump Standards-Version to 3.9.8 (no changes necessary).

 -- Philip Rinn <rinni@inventati.org>  Sun, 25 Sep 2016 22:49:38 +0200
