=== debian/watch ===
version=3
http://rawtherapee.com/shared/source/rawtherapee-(\d[\d.]*)-gtk3\.(?:zip|tgz|tbz2|txz|tar\.gz|tar\.bz2|tar\.xz)
