## rawtherapee 5.2

=== debian/changelog ===
rawtherapee (5.2-1) unstable; urgency=medium

  * New upstream release:
    - Remove build dependency libbz2-dev

 -- Philip Rinn <rinni@inventati.org>  Mon, 24 Jul 2017 11:31:15 +0200

rawtherapee (5.1-2) unstable; urgency=medium

  * Install new binary rawtherapee-cli (closes: #868317):
    - Link man page rawtherapee to rawtherapee-cli
  * Bump Standards-Version to 4.0.0 (no changes necessary).

 -- Philip Rinn <rinni@inventati.org>  Mon, 17 Jul 2017 13:57:49 +0200

rawtherapee (5.1-1) unstable; urgency=medium

  * New upstream release.
  * Add complie flag -fPIC as build fail on some archs without it.

 -- Philip Rinn <rinni@inventati.org>  Wed, 14 Jun 2017 16:10:31 +0200
