=== debian/control ===
--- 
+++ 
@@ -6,7 +6,6 @@
  cmake,
  debhelper (>= 10),
  imagemagick,
- libbz2-dev,
  libcanberra-gtk3-dev,
  libexiv2-dev,
  libexpat1-dev,
@@ -20,7 +19,7 @@
  libsigc++-2.0-dev,
  libtiff-dev,
  zlib1g-dev,
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/rawtherapee.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/rawtherapee.git
 Homepage: http://www.rawtherapee.com
